/* ***** BEGIN LICENSE BLOCK *****
 * Version: NPL 1.1/GPL 2.0/LGPL 2.1
 *
 * The contents of this file are subject to the Netscape Public License
 * Version 1.1 (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.mozilla.org/NPL/
 *
 * Software distributed under the License is distributed on an "AS IS" basis,
 * WITHOUT WARRANTY OF ANY KIND, either express or implied. See the License
 * for the specific language governing rights and limitations under the
 * License.
 *
 * The Original Code is Mike Lee's code.
 *
 * The Initial Developer of the Original Code is
 * Mike Lee.
 * Portions created by the Initial Developer are Copyright (C) 2002
 * the Initial Developer. All Rights Reserved.
 *
 * Contributor(s):
 *	Mike Lee <tseng_mike@yahoo.com>
 *  Cedric Shock <cedricshock@ou.edu>
 *
 * Alternatively, the contents of this file may be used under the terms of
 * either the GNU General Public License Version 2 or later (the "GPL"), or
 * the GNU Lesser General Public License Version 2.1 or later (the "LGPL"),
 * in which case the provisions of the GPL or the LGPL are applicable instead
 * of those above. If you wish to allow use of your version of this file only
 * under the terms of either the GPL or the LGPL, and not to allow others to
 * use your version of this file under the terms of the NPL, indicate your
 * decision by deleting the provisions above and replace them with the notice
 * and other provisions required by the GPL or the LGPL. If you do not delete
 * the provisions above, a recipient may use your version of this file under
 * the terms of any one of the NPL, the GPL or the LGPL.
 *
 * ***** END LICENSE BLOCK ***** */

//var LocalStrings = document.getElementById("bundle_MozBlog");
//Bundle Strins for MozBlog Localisation - Added by P.L. 01-01-03

function extractThenUploadImage(blogContent)
{
  var matchRegex = /<img[^>]+file:[^ ]+\"[^>]*>/gi;
  var urlResultArray = blogContent.match(matchRegex);
  var urlResult;
  var LocalStrings = document.getElementById("bundle_MozBlog");
  if (urlResultArray) {
    for (var i=0; i<urlResultArray.length; i++) {
      // Get the item from the array
      urlResult = urlResultArray[i];

      // Figure out the file name
      matchRegex = /file:[^ ]+\"/gi;
      var imgResult = new String(urlResult);
      imgResult = imgResult.match(matchRegex);
      var finalFile = new String(imgResult)
      finalFile = finalFile.slice(0, finalFile.length - 1);

      // Upload the file
      // Try to detect errors here to make sure post goes through
      // This should be added
      if (1 == 1) {
        document.getElementById("statusbar-display").label = LocalStrings.getString("MozBlog.UploadingImage");
        var upload = new blogUpstream();
        upload.uploadImg(finalFile);
      } else {
        alert (LocalStrings.getString("MozBlog.CouldntUploadImages"));
      }
      // Get the place for the new images
      // Get the HTTP directory that the images will be available in
      var newImgUrl = discussPref.getCharPref("discuss.imageDirHTTP");
      if (!(newImgUrl.length > 0)) {
        // Defaults to previous behaviour
        // If they didn't give us the http path, pretend it's relative
        newImgUrl = discussPref.getCharPref("discuss.imageDir");
      }
      if ( newImgUrl.charAt(newImgUrl.length-1) != '/' )
        newImgUrl = newImgUrl + '/';

      // Find and replace the file names
      var stripImgRegex = /file:\/+.+\//;
      var finalFileName = finalFile.replace(stripImgRegex, "");
      newImgUrl = newImgUrl + finalFileName + "\"";
      blogContent = blogContent.replace(finalFile, newImgUrl);
		}
	}
	return blogContent;
}

function testUploadImg()
{
  var upload = new blogUpstream();
  upload.uploadImg('file:///e:/webLogUpdatesDemoFullPage.gif');
}

function blogUpstream() {}

blogUpstream.prototype = {
  ftpUserName: null,
  ftpPassword: null,
  file: null,
  chann: null,

  constructUrl: function()
  {
    var fileRegex = /file:.+\//;
    var file = this.file.replace(fileRegex, "");
    this.ftpUserName = discussPref.getCharPref("discuss.ftpUsername");
    this.ftpPassword = discussPref.getCharPref("discuss.ftpPassword");
    // generate full path
    fullUrl = discussPref.getCharPref("discuss.ftpServerUrl");
    if ( fullUrl.charAt(fullUrl.length-1) != '/' )
      fullUrl = fullUrl + '/';
    fullUrl = fullUrl + discussPref.getCharPref("discuss.imageDir")
    if ( fullUrl.charAt(fullUrl.length-1) != '/' )
      fullUrl = fullUrl + '/';
    fullUrl = fullUrl + file;

    var regex = /ftp:\/\//gi  //hack to get around the nsIURL::username nsIURL::password bug?
    fullUrl = fullUrl.replace(regex, "ftp://" + this.ftpUserName + ":" + this.ftpPassword + "@");
    return fullUrl;
  },

  uploadImg: function (upFilename)
  {
    this.file = upFilename;
    this.chann = this.ftpUpload(this.constructUrl(), this.file);
    this.chann.asyncOpen(this, null);
  },

  ftpUpload: function (destUrl, fileUrl)
  {
    //create stream [nsIInputStream]
    var ioService = Components.classes["@mozilla.org/network/io-service;1"]
                              .getService(Components.interfaces.nsIIOService);
    var url = Components.classes["@mozilla.org/network/standard-url;1"];
    fileurl = url.createInstance(Components.interfaces.nsIURL);
    fileurl.spec = fileUrl;
    var srcChannel = ioService.newChannelFromURI(fileurl);
    if (!srcChannel) {
      dump("can't create src channel\n");
      return;
    }

    var remoteUrl = url.createInstance(Components.interfaces.nsIURL);
    remoteUrl.spec = destUrl;

    if (remoteUrl.scheme == 'ftp') {
      if (this.ftpUserName) { // insert user/pass
        remoteUrl.username = this.ftpUserName;
        if (this.ftpPassword) {
          remoteUrl.password = this.ftpPassword;
        }
      }
      var ftpChannel = ioService.newChannelFromURI(remoteUrl)
                        .QueryInterface(Components.interfaces.nsIUploadChannel);
      if (!ftpChannel) {
        dump("failed to get ftp channel\n");
        return;
      }

      // using bufferedstream because of bug http://bugzilla.mozilla.org/show_bug.cgi?id=159955
      var bufferedStream = Components.classes["@mozilla.org/network/buffered-input-stream;1"]
                                     .createInstance(Components.interfaces.nsIBufferedInputStream);
      bufferedStream.init(srcChannel.open(), srcChannel.contentLength);
      ftpChannel.setUploadStream(bufferedStream, null, -1);
      //ftpChannel.asyncOpen(blogUpstream(), null);
      return ftpChannel;
    } else {
      var LocalStrings = document.getElementById("bundle_MozBlog");
      alert (LocalStrings.getString("MozBlog.OnlyFtpServer"));
      return null;
    }
  },

  onStartRequest: function(request, ctxt) {
    dump("onStartRequest status = " + request.status + "\n");
  },
  onStopRequest: function(request, ctxt, status, errorMsg) {
    dump("onStopRequest status = " + lookUpError(request.status) + " " + errorMsg + "\n");
    var request = this.chann.QueryInterface(Components.interfaces.nsIRequest);
    request.cancel(-1);
//		  document.getElementById("statusbar-display").label = "Image uploaded"
  },

  onDataAvailable: function(request, ctxt, inStream, sourceOffset, count) {
    dump("onDataAvailable status = " + request.status + " " + count + "\n");
  }
};

function lookUpError(aErrorNum) {
  var r	   = Components.results;
  var retval  = null;
  for(var list in r)
    if(aErrorNum==r[list])
      retval=list;
  return retval;
}

